from django.forms import ModelForm
from .models import *
from django import forms


    
class CompanyProfileForm(ModelForm):
    class Meta:
        model = CompanyProfile
        fields = '__all__'
        
        
class CompanyLocationForm(ModelForm):
    class Meta:
        model = CompanyLocation
        fields = ('name', 'phone')
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
            'phone': forms.TextInput(attrs={'class': 'form-control'}),
        }
        
        
class CompanyProfileForm(ModelForm):
    class Meta:
        model = CompanyProfile
        fields = {'name', 'phone', 'email', 'address', 'vatNo', 'vatRate', 'website', 'NHIL_Rate', 'A4_Printer', 'no_of_receipts', 'show_vat', 'firstTextBelowReceipt', 'secondTextBelowReceipt'}
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
            'phone': forms.TextInput(attrs={'class': 'form-control'}),
            'email': forms.TextInput(attrs={'class': 'form-control'}),
            'address': forms.TextInput(attrs={'class': 'form-control'}),
            'vatNo': forms.TextInput(attrs={'class': 'form-control'}),
            'vatRate': forms.NumberInput(attrs={'class': 'form-control'}),
            'website': forms.TextInput(attrs={'class': 'form-control'}),
            'NHIL_Rate': forms.NumberInput(attrs={'class': 'form-control'}),
            'no_of_receipts': forms.NumberInput(attrs={'class': 'form-control'}),
            'firstTextBelowReceipt': forms.TextInput(attrs={'class': 'form-control'}),
            'secondTextBelowReceipt': forms.TextInput(attrs={'class': 'form-control'}),
            'show_vat': forms.CheckboxInput(),
            'A4_Printer': forms.CheckboxInput(),	
        }
        
        
class ProductCategoryForm(ModelForm):
    class Meta:
        model = ProductCategory
        fields = ('name', 'description')
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
            'description': forms.TextInput(attrs={'class': 'form-control'}),
        }
        
        
class ProductsForm(ModelForm):
    class Meta:
        model = Products
        fields = ('name', 'baseUnit', 'category', 'reorderLevel', 'is_active')
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }),
            'category': forms.Select(attrs={'class': 'form-control'}),
            'baseUnit': forms.Select(attrs={'class': 'form-control'}),
            'reorderLevel': forms.NumberInput(attrs={'class': 'form-control'}),
            'is_active': forms.CheckboxInput(),
        }
        
        
class ProductPriceForm(ModelForm):   
    class Meta:
        model = ProductPrice
        fields = ('product', 'package', 'qty_in_package', 'stockLevel', 'cost_price', 'VAT', 'NHIL', 'margin', 'sale_type', 'companylocation')
        
        widgets = {
            'product': forms.Select(attrs={'class': 'form-control', }), 
            'package': forms.Select(attrs={'class': 'form-control', }), 
            'qty_in_package': forms.NumberInput(attrs={'class': 'form-control'}),
            'stockLevel': forms.NumberInput(attrs={'class': 'form-control'}),
            'cost_price': forms.NumberInput(attrs={'class': 'form-control', 'label': 'Cost Price (PCP)'}),
            'VAT': forms.NumberInput(attrs={'class': 'form-control'}),
            'NHIL': forms.NumberInput(attrs={'class': 'form-control'}),
            'margin': forms.NumberInput(attrs={'class': 'form-control'}),	
            'sale_type': forms.Select(attrs={'class': 'form-control', }),	
            'companylocation': forms.Select(attrs={'class': 'form-control', }),	
        }
   
        
class ProductStockForm(ModelForm):
    class Meta:
        model = ProductPrice
        fields = ('stockLevel',)
        
        widgets = {
            'stockLevel': forms.NumberInput(attrs={'class': 'form-control'}),
        }
        
        
        

class CustomersForm(ModelForm):
    class Meta:
        model = Customer
        fields = ('name', 'phone', 'email', 'address', 'total_credit', 'total_paid', 'creditLimit', 'registration_date', 'is_active')
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
            'phone': forms.TextInput(attrs={'class': 'form-control', }),
            'email': forms.TextInput(attrs={'class': 'form-control'}),
            'address': forms.TextInput(attrs={'class': 'form-control'}),
            'total_credit': forms.NumberInput(attrs={'class': 'form-control', 'placeholder': 'Amount Owing'}),
            'total_paid': forms.NumberInput(attrs={'class': 'form-control', 'placeholder': 'Amount Paid'}),
            'creditLimit': forms.NumberInput(attrs={'class': 'form-control', }),
            'registration_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date', }),
            'is_active': forms.CheckboxInput(),
        }
        
        
        
        
class SupplierForm(ModelForm):
    class Meta:
        model = Supplier
        fields = ('name', 'phone', 'email', 'address', 'debit', 'credit', 'is_active')
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
            'phone': forms.TextInput(attrs={'class': 'form-control'}),
            'email': forms.TextInput(attrs={'class': 'form-control'}),
            'address': forms.TextInput(attrs={'class': 'form-control'}),
            'debit': forms.NumberInput(attrs={'class': 'form-control'}),
            'credit': forms.NumberInput(attrs={'class': 'form-control'}),
            'is_active': forms.CheckboxInput(),
        }
        
        
        
class BankAccountForm(ModelForm):
    class Meta:
        model = BankAccounts
        fields = ('account_number', 'bank', 'account_name', 'opening_date', 'account_type', 'opening_balance', 'bank_branch')
        
        widgets = {
            'account_number': forms.NumberInput(attrs={'class': 'form-control'}),
            'bank': forms.Select(attrs={'class': 'form-control'}),
            'account_name': forms.TextInput(attrs={'class': 'form-control'}),
            'opening_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'account_type': forms.Select(attrs={'class': 'form-control'}),
            'opening_balance': forms.NumberInput(attrs={'class': 'form-control'}),
            'bank_branch': forms.TextInput(attrs={'class': 'form-control'}),
        }
        
        

class PaletForm(ModelForm):
    class Meta:
        model = BatchPaleting
        fields = ('batch_number', 'product', 'color', 'active')
        



        widgets = {
            'batch_number': forms.TextInput(attrs={'class': 'form-control', }),
            'product': forms.Select(attrs={'class': 'form-control'}),
            'color': forms.Select(attrs={'class': 'form-control'}),
            'active': forms.CheckboxInput(),
        }
        
        
class PackageForm(ModelForm):
    class Meta:
        model = Package
        fields = ('name',)
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
        }
        
        
        
class ColorsForm(ModelForm):
    class Meta:
        model = Colors
        fields = ('color',)
        
        widgets = {
            'color': forms.TextInput(attrs={'class': 'form-control', }), 
        }
        
        
        
class ExpenseTypeForm(ModelForm):
    class Meta:
        model = ExpenseType
        fields = ('name',)
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
        }
        
        
        
class BankForm(ModelForm):
    class Meta:
        model = Bank
        fields = ('name',)
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
        }
        
        
        
class PaymentModeForm(ModelForm):
    class Meta:
        model = PaymentMode
        fields = ('name',)
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
        }
        
        
class TransactionTypeForm(ModelForm):
    class Meta:
        model = BankTransactionType
        fields = ('name',)
        
        widgets = {
            'name': forms.TextInput(attrs={'class': 'form-control', }), 
        }
        
        
        
        
class StockLevelForm(ModelForm):
    class Meta:
        model = ProductPrice
        fields = ('stockLevel',)
        
        widgets = {
            'stockLevel': forms.TextInput(attrs={'class': 'form-control', }), 
        }
        
        
        
class CreditSalePaymentForm(ModelForm):
    class Meta:
        model = CreditSalePayment
        fields = ('payment_date', 'customer', 'company_location', 'amount', 'paid_by', 'payment_mode', 'cheque_number', 'cheque_date', 'bank', 'bank_branch')
        
        widgets = {
            'payment_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'customer': forms.Select(attrs={'class': 'form-control'}),
            'company_location': forms.Select(attrs={'class': 'form-control'}),
            'amount': forms.NumberInput(attrs={'class': 'form-control'}),
            'paid_by': forms.TextInput(attrs={'class': 'form-control'}),
            'payment_mode': forms.Select(attrs={'class': 'form-control'}),
            'cheque_number': forms.NumberInput(attrs={'class': 'form-control'}),
            'cheque_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'bank': forms.Select(attrs={'class': 'form-control'}),
            'bank_branch': forms.TextInput(attrs={'class': 'form-control'}), 
        } 




class CreditCashPaymentForm(ModelForm):
    class Meta:
        model = CreditSalePayment
        fields = ('payment_date', 'customer', 'company_location', 'amount', 'paid_by')
        
        widgets = {
            'payment_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'customer': forms.Select(attrs={'class': 'form-control'}),
            'company_location': forms.Select(attrs={'class': 'form-control'}),
            'amount': forms.NumberInput(attrs={'class': 'form-control'}),
            'paid_by': forms.TextInput(attrs={'class': 'form-control'}),
            'payment_mode': forms.Select(attrs={'class': 'form-control'}),
            'cheque_number': forms.NumberInput(attrs={'class': 'form-control'}),
            'cheque_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'bank': forms.Select(attrs={'class': 'form-control'}),
            'bank_branch': forms.TextInput(attrs={'class': 'form-control'}), 
        } 



class stockPurchasePaymentForm(ModelForm):
    class Meta:
        model = StockPurchasePayment
        fields = ('payment_date', 'supplier', 'amount', 'paid_by', 'payment_mode', 'cheque_number', 'cheque_date', 'bank', 'bank_branch')
        
        widgets= {
            'payment_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'supplier': forms.Select(attrs={'class': 'form-control'}),
            'amount': forms.NumberInput(attrs={'class': 'form-control'}),
            'paid_by': forms.TextInput(attrs={'class': 'form-control'}),
            'payment_mode': forms.Select(attrs={'class': 'form-control'}),
            'cheque_number': forms.NumberInput(attrs={'class': 'form-control'}),
            'cheque_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'bank': forms.Select(attrs={'class': 'form-control'}),
            'bank_branch': forms.TextInput(attrs={'class': 'form-control'}),
            
        }


class ExpenseForm(ModelForm):
    class Meta:
        model = Expenses
        fields = ('companylocation', 'expense_date', 'expense_type', 'amount', 'payment_mode', 'cheque_number', 'cheque_date', 'bank_account', 'description')
        widgets = {
            'companylocation': forms.Select(attrs={'class': 'form-control', }),
            'expense_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'expense_type': forms.Select(attrs={'class': 'form-control', }),
            'description': forms.Textarea(attrs={'class': 'form-control', 'rows': '2'}),
            'amount': forms.NumberInput(attrs={'class': 'form-control', }),
            'payment_mode': forms.Select(attrs={'class': 'form-control'}),
            'cheque_number': forms.NumberInput(attrs={'class': 'form-control'}),
            'cheque_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'bank_account': forms.Select(attrs={'class': 'form-control', }),
        }



class BankTransactionForm(ModelForm):
    class Meta:
        model = BankTransaction
        fields = ('companylocation', 'transaction_date', 'transaction_type', 'amount', 'transacted_by', 'notes', 'payment_mode', 'cheque_number', 'cheque_date', 'bank_account')
        widgets = {
            'companylocation': forms.Select(attrs={'class': 'form-control', }),
            'transaction_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'transaction_type': forms.Select(attrs={'class': 'form-control', }),
            'notes': forms.Textarea(attrs={'class': 'form-control', 'rows': '2',}),
            'amount': forms.NumberInput(attrs={'class': 'form-control', }),
            'transacted_by': forms.TextInput(attrs={'class': 'form-control', }),
            'payment_mode': forms.Select(attrs={'class': 'form-control', }),
            'cheque_number': forms.NumberInput(attrs={'class': 'form-control'}),
            'cheque_date': forms.DateInput(attrs={'class': 'form-control', 'type': 'date'}),
            'bank_account': forms.Select(attrs={'class': 'form-control', }),
        }




class CreditSaleApprovalForm(forms.ModelForm):
    class Meta:
        model = CreditSaleApproval
        
        fields = ('status', 'comments')
        
        widgets = {
            'status': forms.Select(attrs={'class': 'form-control'}),
            'comments': forms.Select(attrs={'class': 'form-control'})
        }


        
class approvalCommentForm(forms.ModelForm):
    class Meta:
        model = approval_comment
        
        fields = ('comments',)
        
        widgets = {
            'comments': forms.Textarea(attrs={'class': 'form-control'}),
        }


        
        